<?php
#
# cacti script for reading Cisco advanced CPU MIB
#
/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
   die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true; 
/* display No errors */
error_reporting(0);

include_once(dirname(__FILE__) . "/../include/config.php");
include_once(dirname(__FILE__) . "/../lib/snmp.php");

if (!isset($called_by_script_server)) {
	 include_once(dirname(__FILE__) . "/../include/global.php");
	array_shift($_SERVER["argv"]);
	print call_user_func_array("ss_cisco_cbwfq", $_SERVER["argv"]);
}

function ss_cisco_cbwfq($hostname, $snmp_community, $snmp_version,
                        $snmp_port, $snmp_timeout, $snmp_user, $snmp_pw,
                        $cmd, $query_field = "", $query_index = "") {
 $snmp_timeout = ($snmp_timeout * 1000);
 $cmdoutput = array();
 $xml_delimiter = "!";
 
 $oids = array(
  "config"       => ".1.3.6.1.4.1.9.9.166.1.7.1.1.1", # list of all configured QoS classes
  "config_index" => ".1.3.6.1.4.1.9.9.166.1.5.1.1.2",  # cbQosConfigIndex
  "int_index"    => ".1.3.6.1.4.1.9.9.166.1.1.1.1.4",  # cbQosIfIndex
  "policy_direction" => ".1.3.6.1.4.1.9.9.166.1.1.1.1.3", # cbQosPolicyDirection
  "int_name"        => ".1.3.6.1.2.1.31.1.1.1.1",
  "int_description" => ".1.3.6.1.2.1.31.1.1.1.18",
  "class_traffic" =>  ".1.3.6.1.4.1.9.9.166.1.15.1.1.11",
  "pre_class_traffic" => ".1.3.6.1.4.1.9.9.166.1.15.1.1.7",
  "drop_class_traffic" => ".1.3.6.1.4.1.9.9.166.1.15.1.1.18",
  "drop_class_byte"  => ".1.3.6.1.4.1.9.9.166.1.15.1.1.17",
  "pre_class_byte" => ".1.3.6.1.4.1.9.9.166.1.15.1.1.6",
  "class_byte"  =>  ".1.3.6.1.4.1.9.9.166.1.15.1.1.10",
  );
 
 # get number of snmp retries from global settsnm ings
 $snmp_retries   = read_config_option("snmp_retries");
 
 if ($cmd == "index" OR $cmd == "query") {
 
 $result_conf = cacti_snmp_walk($hostname, $snmp_community, $oids["config"], $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
 $result_config_index =  cacti_snmp_walk($hostname, $snmp_community, $oids["config_index"], $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
 $result_int_index = cacti_snmp_walk($hostname, $snmp_community, $oids["int_index"], $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
 $result_policy_direction = cacti_snmp_walk($hostname, $snmp_community, $oids["policy_direction"], $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
 
 # processing all query requests for each config class on the interface
 
 #var_dump($result_conf);
 
 foreach ($result_conf as $line) {
  preg_match('/\d+$/', $line["oid"], $last_oid_number);
  $config[$last_oid_number[0]] = $line["value"];
 }
 
 foreach ($result_int_index as $line) {
  preg_match ('/\d+$/', $line["oid"], $last_oid_number);
  $int_index[$last_oid_number[0]] = $line["value"];
 }
 
 foreach ($result_policy_direction as $line) {
  preg_match('/\d+$/', $line["oid"], $last_oid_number);
  $policy_direction[$last_oid_number[0]] = $line["value"];
 }
 
 #var_dump($config, $result_int_index, $int_index, $policy_direction);
 
 foreach ($result_config_index as $line) {
  if (array_key_exists($line["value"], $config)) {
   $idx2 = $config[$line["value"]];
   preg_match ('/(\d+).(\d+)$/', $line["oid"], $last_oid_numbers);
   if ($last_oid_numbers[1]) {
    $idx1 = $int_index[$last_oid_numbers[1]];
    $idx3 = $policy_direction[$last_oid_numbers[1]];
    
    $idx4 = $last_oid_numbers[1];
    $idx5 = $last_oid_numbers[2];
 

 if ($cmd == "index") {
  print("$idx1.$idx2.$idx3.$idx4.$idx5\n");
 }
 # indexed indexes
 elseif ($cmd == "query" AND $query_field == "index") {
  print("$idx1.$idx2.$idx3.$idx4.$idx5$xml_delimiter$idx1.$idx2.$idx3.$idx4.$idx5\n");
 }
 # get direction of policy
 elseif ($cmd == "query" AND $query_field == "direction") {
  if ($idx3 == "1") {
   print("$idx1.$idx2.$idx3.$idx4.$idx5$xml_delimiter"."Inbound\n");
  }
  if ($idx3 == "2") {
   print("$idx1.$idx2.$idx3.$idx4.$idx5$xml_delimiter"."Outbound\n");
  }
  }
  # get interface names
  elseif ($cmd == "query" AND $query_field == "ifname") {
   $oid = $oids["int_name"].".".$idx1;
   $int_name = cacti_snmp_get($hostname, $snmp_community, $oid, $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
   print ("$idx1.$idx2.$idx3.$idx4.$idx5$xml_delimiter$int_name\n");
  }
  # get interface description
  elseif ($cmd == "query" AND $query_field == "ifdescription") {
   $oid = $oids["int_description"].".".$idx1;
   $int_descr = cacti_snmp_get($hostname, $snmp_community, $oid, $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
   print ("$idx1.$idx2.$idx3.$idx4.$idx5$xml_delimiter$int_descr\n");
  }
  #get QoS class names
  elseif ($cmd == "query" AND $query_field == "qosname") {
   print "$idx1.$idx2.$idx3.$idx4.$idx5$xml_delimiter$idx2\n";
  }
  
   } # if ($last_oid_numbers[1])
   else { return 0; }
 
 } #if (array_key_exists($line["value"], $result_conf_oid))
 } # foreach ($result_config_index as $line)
 } # ($cmd == "index" OR $cmd == "query")
 
   #getting class traffic 
 if ($cmd == "get" AND $query_field == "qosbitrate") {
  $index = splitQueryIndex($query_index);
  $oid = $oids["class_traffic"].".".$index[1].".".$index[2];
  $class_traffic = cacti_snmp_get($hostname, $snmp_community, $oid, $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
  return $class_traffic;
 }
 # getting pre_class_traffic
 elseif ($cmd == "get" AND $query_field == "qosprecbitrate") {
  $index = splitQueryIndex($query_index);
  $oid = $oids["pre_class_traffic"].".".$index[1].".".$index[2];
  $pre_class_traffic = cacti_snmp_get($hostname, $snmp_community, $oid, $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
  return $pre_class_traffic;
 }
 # getting drop class traffic
 elseif ($cmd == "get" AND $query_field == "qosdropbitrate") {
  $index = splitQueryIndex($query_index);
  $oid = $oids["drop_class_traffic"].".".$index[1].".".$index[2];
  $drop_class_traffic = cacti_snmp_get($hostname, $snmp_community, $oid, $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
  return $drop_class_traffic;
 }
 # getting drop class bytes
 if ($cmd == "get" AND $query_field == "qosdropbyte") {
  $index = splitQueryIndex($query_index);
  $oid = $oids["drop_class_byte"].".".$index[1].".".$index[2];
  $drop_class_byte = cacti_snmp_get($hostname, $snmp_community, $oid, $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
  return $drop_class_byte;
 }
  # getting pre class bytes
 if ($cmd == "get" AND $query_field == "qosprecbyte") {
  $index = splitQueryIndex($query_index);
  $oid = $oids["pre_class_byte"].".".$index[1].".".$index[2];
  $pre_class_byte = cacti_snmp_get($hostname, $snmp_community, $oid, $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
  return $pre_class_byte;
 }
 # getting class bytes
 if ($cmd == "get" AND $query_field == "qosbyte") {
  $index = splitQueryIndex($query_index);
  $oid = $oids["class_byte"].".".$index[1].".".$index[2];
  $class_byte = cacti_snmp_get($hostname, $snmp_community, $oid, $snmp_version,
                                $snmp_user, $snmp_pw, "", "", "", "",
                                $snmp_port, $snmp_timeout, $snmp_retries);
  return $class_byte;
 }
}

function splitQueryIndex($query_index) {
 preg_match('/(\d+).(\d+)$/', $query_index, $index);
 return ($index);
}








































?>
